import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {Class} from './class';
import {Executable} from './executable';

export class Constructor extends Executable {
  private _rawConstructor: Function;

  public constructor(declaringClazz: Class, parameterTypes?: any[]) {
    super(declaringClazz, CONSTRUCTOR_NAME, parameterTypes);
    this._rawConstructor = TypeUtil.getPrototype(declaringClazz.getType())[CONSTRUCTOR_NAME];
  }

  public newInstance(...args: any[]): any {
    let ctor = this.getDeclaringClass().getType();
    return new (ctor.bind.apply(ctor, [null].concat(args)))();
  }
}

const CONSTRUCTOR_NAME = 'constructor';
